import _extends from "@babel/runtime/helpers/extends";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import "core-js/modules/es.array.map.js";
import * as React from 'react';
import { Carousel } from '@megafon/ui-core';
import { breakpoints, cnCreate, filterDataAttrs } from '@megafon/ui-helpers';
import useResolutions from "../../hooks/useResolutions";
import DarkGradientCard from "./components/DarkGradientCard";
import "./DarkGradientCards.css";
var carouselParams = _defineProperty({}, breakpoints.MOBILE_SMALL_START, {
  slidesPerView: 'auto',
  spaceBetween: 20
});
var CAROUSEL_THRESHOLD = 5;
var MIN_ITEMS_COUNT = 3;
var cn = cnCreate('mfui-dark-gradient-cards');
var DarkGradientCards = function DarkGradientCards(_ref) {
  var items = _ref.items,
    _ref$carouselGradient = _ref.carouselGradientColor,
    carouselGradientColor = _ref$carouselGradient === void 0 ? 'default' : _ref$carouselGradient,
    _ref$carouselNavTheme = _ref.carouselNavTheme,
    carouselNavTheme = _ref$carouselNavTheme === void 0 ? 'light' : _ref$carouselNavTheme,
    className = _ref.className,
    _ref$classes = _ref.classes,
    classes = _ref$classes === void 0 ? {} : _ref$classes,
    dataAttrs = _ref.dataAttrs,
    onCarouselChange = _ref.onCarouselChange,
    rootRef = _ref.rootRef;
  var _useResolutions = useResolutions(),
    isDesktopWide = _useResolutions.isDesktopWide;
  var isCarouselActive = items.length > MIN_ITEMS_COUNT || items.length === MIN_ITEMS_COUNT && !isDesktopWide;
  var cards = items.map(function (item, i) {
    return /*#__PURE__*/React.createElement(DarkGradientCard, _extends({}, item, {
      key: item.title + i,
      size: i === 0 ? 'big' : 'small',
      className: cn('card'),
      classes: {
        root: classes.item,
        title: classes.itemTitle
      },
      dataAttrs: {
        root: _extends({}, filterDataAttrs(dataAttrs === null || dataAttrs === void 0 ? void 0 : dataAttrs.item, i + 1))
      }
    }));
  });
  if (items.length < MIN_ITEMS_COUNT) {
    return null;
  }
  return /*#__PURE__*/React.createElement("div", _extends({}, filterDataAttrs(dataAttrs === null || dataAttrs === void 0 ? void 0 : dataAttrs.root), {
    className: cn([className, classes.root]),
    ref: rootRef
  }), isCarouselActive ? /*#__PURE__*/React.createElement(Carousel, {
    dataAttrs: {
      root: _extends({}, filterDataAttrs(dataAttrs === null || dataAttrs === void 0 ? void 0 : dataAttrs.carousel))
    },
    slidesSettings: carouselParams,
    navTheme: carouselNavTheme,
    threshold: CAROUSEL_THRESHOLD,
    gradient: true,
    gradientColor: carouselGradientColor,
    onChange: onCarouselChange
  }, cards) : /*#__PURE__*/React.createElement("div", {
    className: cn('cards')
  }, cards));
};
export default DarkGradientCards;